#    Massive Enumeration Toolset
#    Copyright (C) 2005  Petko Petkov (GNUCITIZEN) ppetkov@gnucitizen.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import urllib
import cStringIO
import xml.dom.pulldom

class GHDBTool:
	def __init__(self):
		self.__data = None 
		self.__filter = None

	def load(self, url):
		try:
			self.__data = cStringIO.StringIO()
			self.__data.write(urllib.urlopen(url).read())

		except:
			raise IOError, 'cannot open database %s for reading' % url

	def save(self, file):
		try:
			file = open(file, 'w')
			file.write(self.__data.getvalue())

		except:
			raise IOError, 'cannot write database to %s' % file

	def filter(self, filter):
		self.__filter = filter

	def iterrecords(self):
		try:
			xmldoc = xml.dom.pulldom.parseString(self.__data.getvalue())

		except:
			raise RuntimeError, 'no database loaded'

		while True:
			while True:
				element = xmldoc.getEvent()

				if element == None:
					node = None
					break

				type, node = element

				if type == xml.dom.pulldom.START_ELEMENT and node.nodeName == 'signature':
					break

			if node == None:
				break

			xmldoc.expandNode(node)

			try:
				record = {}

				record['signatureReferenceNumber'] = int(node.getElementsByTagName('signatureReferenceNumber')[0].firstChild.data)
				record['categoryref'] = node.getElementsByTagName('categoryref')[0].firstChild.data 
				record['category'] = node.getElementsByTagName('category')[0].firstChild.data
				record['querytype'] = node.getElementsByTagName('querytype')[0].firstChild.data
				record['querystring'] = node.getElementsByTagName('querystring')[0].firstChild.data
				record['shortDescription'] = node.getElementsByTagName('shortDescription')[0].firstChild.data
				record['textualDescription'] = node.getElementsByTagName('textualDescription')[0].firstChild.data
				record['cveNumber'] = int(node.getElementsByTagName('cveNumber')[0].firstChild.data)
				record['cveLocation'] = node.getElementsByTagName('cveLocation')[0].firstChild.data

			except:
				raise RuntimeError, 'unfamiliar data stucture'

			if self.__filter != None:
				try:
					if eval(self.__filter, None, record) == True:
						yield record

				except:
					raise SyntaxError, 'filter \'%s\' cannot be evaluated' % self.__filter

			else:
				yield record

	def records(self):
		records = []

		for record in self.iterrecords():
			records.append(record)

		return records

	def allrecords(self):
		oldfilter = self.__filter
		self.__filter = None

		records = self.records()

		self.__filter = oldfilter

		return records
