#    Massive Enumeration Toolset
#    Copyright (C) 2005  Petko Petkov (GNUCITIZEN) ppetkov@gnucitizen.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import re
import urllib
import urllib2

class GoogleLabsTool:
	def makeHTTPrequest(self, type, parameters):
		return 'http://labs.google.com/%s?%s' % (type, urllib.urlencode(parameters))

	def parseHTTPresponse(self, response):
		return response

	def sendHTTPrequest(self, type, parameters):
		request = self.makeHTTPrequest(type, parameters)

		try:
			request = urllib2.Request(request)
			request.add_header('User-Agent', 'Mozilla/5.0 Gecko/20050716 Firefox/1.0.6')

			opener = urllib2.build_opener()
			response = opener.open(request).read()

		except:
			raise RuntimeError, 'unable to request from labs.google.com'

		return self.parseHTTPresponse(response)

class GoogleSetsTool(GoogleLabsTool):
	def parseHTTPresponse(self, response):
		results = []

		p = re.compile('<font face="Arial, sans-serif" size=-1><a href="http://www.google.com/search\?hl=en&q=.*"><center>(.*)</center></a></font>')

		for line in response.split('\n'):
			line = line.strip()

			match = p.match(line)

			if match:
				results.append(match.group(1))

		if len(results) == 0:
			return None

		return results

	def search(self, *terms):
		vars = {}

		for i in range(len(terms)):
			vars['q' + repr(i + 1)] = terms[i]

		return self.sendHTTPrequest('sets', vars)
